<template>
  <div class="app-container">
    <!-- 查询和其他操作 -->
    <div class="filter-container" style="margin: 10px 0 10px 0;" >
      <el-button class="filter-item" type="primary" @click="handleAdd" icon="el-icon-edit" >新增域名</el-button>
    </div>

    <el-table :data="tableData"
              style="width: 100%"
              @selection-change="handleSelectionChange"
              @sort-change="changeSort"
              :default-sort="{prop: 'sort', order: 'descending'}">
      <!--<el-table-column type="selection"></el-table-column>

      <el-table-column label="序号" width="60" align="center">
        <template slot-scope="scope">
          <span>{{scope.$index + 1}}</span>
        </template>
      </el-table-column>-->
      <el-table-column label="域名" width="200" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.domainName }}</span>
        </template>
      </el-table-column>
      <el-table-column label="类型" width="100">
        <template slot-scope="scope">
          <template v-if="scope.row.domainType == 1">
            <span>启动页</span>
          </template>
          <template v-if="scope.row.domainType == 2">
            <span>收银台</span>
          </template>
        </template>
      </el-table-column>

      <el-table-column label="创建时间" width="160" align="center" prop="createTime" sortable="custom" :sort-by="['createTime']">
        <template slot-scope="scope">
          <span>{{ scope.row.createTime }}</span>
        </template>
      </el-table-column>
      <el-table-column label="更新时间" width="160" align="center" prop="updateTime" sortable="custom" :sort-by="['updateTime']">
        <template slot-scope="scope">
          <span>{{ scope.row.updateTime }}</span>
        </template>
      </el-table-column>

      <el-table-column label="操作" fixed="right" min-width="100">
        <template slot-scope="scope">
          <el-button @click="handleEdit(scope.row)" type="primary" size="small">编辑</el-button>
          <el-button @click="handleDelete(scope.row)" type="danger" size="small">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!--分页-->
    <div class="block">
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page.sync="currentPage"
        :page-size="pageSize"
        layout="total, prev, pager, next, jumper, sizes"
        :total="total"
      ></el-pagination>
    </div>

    <!-- 添加或修改对话框 -->
    <el-dialog :title="title" :visible.sync="dialogFormVisible" width="30%" :before-close="handleClose">
      <el-form :model="form" :rules="rules" ref="form">
        <el-form-item label="域名" :label-width="formLabelWidth" prop="name">
          <el-input v-model="form.domainName" auto-complete="off"></el-input>
        </el-form-item>
        <el-form-item label="域名分类" :label-width="formLabelWidth" prop="bannerType">
          <el-select v-model="form.domainType" placeholder="位置"  class="filter-item" style="width: 200px;">
            <el-option label="启动页" value="1">启动页</el-option>
            <el-option label="收银台" value="2">收银台</el-option>
          </el-select>
        </el-form-item>
      </el-form>


      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogFormVisible = false">取 消</el-button>
        <el-button type="primary" @click="submitForm">确 定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  getDomainList,
  addDomain,
  editDomain,
  deleteDomain,
} from "@/api/domain";
export default {
  data() {
    return {
      multipleSelection: [], //多选，用于批量删除
      tableData: [],
      name: "",
      currentPage: 1,
      pageSize: 10,
      total: 0, //总数量
      title: "增加域名",
      dialogFormVisible: false, //控制弹出框
      formLabelWidth: "120px",
      isEditForm: false,
      orderByDescColumn: "", // 降序字段
      orderByAscColumn: "", // 升序字段
      form: {
        domainName: "",
        domainType: "",
      },
      rules: {
        domainName: [
          {required: true, message: '域名不能为空', trigger: 'blur'},
          {min: 1, max: 200, message: '长度在1到200个字符'},
        ],

      }
    };
  },
  created() {
    this.domainList();
  },
  methods: {
    // 从后台获取数据,重新排序
    changeSort (val) {
      // 根据当前排序重新获取后台数据,一般后台会需要一个排序的参数
      if(val.order == "ascending") {
        this.orderByAscColumn = val.prop
        this.orderByDescColumn = ""
      } else {
        this.orderByAscColumn = ""
        this.orderByDescColumn = val.prop
      }
      this.domainList()
    },
    domainList: function() {
      var params = {};
      params.name = this.name;
      params.currentPage = this.currentPage
      params.pageSize = this.pageSize
      getDomainList(params).then(response => {
        this.tableData = response.data.records;
        this.currentPage = response.data.current;
        this.pageSize = response.data.size;
        this.total = response.data.total;
      });
    },
    getFormObject: function() {
      var formObject = {
        uid: null,
        content: null,
        clickCount: 0,
        sort: 0
      };
      return formObject;
    },
    handleAdd: function() {
      this.title = "增加域名"
      this.dialogFormVisible = true;
      this.form = this.getFormObject();
      this.isEditForm = false;
    },
    handleEdit: function(row) {
      this.title = "编辑域名";
      this.dialogFormVisible = true;
      this.isEditForm = true;
      this.form = row;
    },
    /*删除*/
    handleDelete: function(row) {
      this.$confirm("此操作将把分类删除, 是否继续?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
        .then(() => {
          deleteDomain(row).then(response => {
            if(response.code == this.$ECode.SUCCESS) {
              this.$commonUtil.message.success(response.message)
            } else {
              this.$commonUtil.message.error(response.message)
            }
            this.domainList();
          });
        })
        .catch(() => {
          this.$commonUtil.message.info("已取消删除")
        });
    },
    /**
     * 翻页事件
     */
    handleSizeChange(val) {
      this.pageSize = val;
      this.domainList();
    },
    handleCurrentChange: function(val) {
      this.currentPage = val;
      this.domainList();
    },
    submitForm: function() {
      this.$refs.form.validate((valid) => {
        if(!valid) {
          console.log('校验失败')
          return;
        } else {
          if (this.isEditForm) {
            editDomain(this.form).then(response => {
              if (response.code == this.$ECode.SUCCESS) {
                this.$commonUtil.message.success(response.message)
                this.dialogFormVisible = false;
                this.domainList();
              } else {
                this.$commonUtil.message.error(response.message)
              }
            });
          } else {
            addDomain(this.form).then(response => {
              console.log(response);
              if (response.code == this.$ECode.SUCCESS) {
                this.$commonUtil.message.success(response.message)
                this.dialogFormVisible = false;
                this.domainList();
              } else {
                this.$commonUtil.message.error(response.message)
              }
            });
          }
        }
      })
    },
    // 改变多选
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },

    handleClose(){
      this.dialogFormVisible = false;
      this.$refs.form.clearValidate();
    },
  }
};
</script>
